
QGIS Application - Bug report #15930

Aggregate functions don't seem to work with virtual fields

2016-12-02 07:51 AM - jd lom

Status: Closed

Priority: Normal

Assignee:

Category: Virtual Fields

Affected QGIS version:2.18.10 Regression?: No

Operating System: Windows Easy fix?: No

Pull Request or Patch supplied:No Resolution:

Crashes QGIS or corrupts data:No Copied to github as #: 23847

Description

Only test with sum, count_distinct.

sum("value", "id_zone") works well with standard fields but return NULL value with virtual fields

Associated revisions

Revision 3f4d6de5 - 2017-07-14 02:21 AM - Nyall Dawson

Fix aggregate expression calculation when used with virtual fields

The layer expression context (which is required for aggregate

calculation to work) was not being added to the context used

by vector layer feature iterators.

Fix #15930

History

#1 - 2017-05-01 01:02 AM - Giovanni Manghi

- Easy fix? set to No

- Regression? set to No

#2 - 2017-05-19 09:14 AM - Patrice Vetsel -

- Description updated

I can confirm this bug too on 2.18.7

Using this :

relation_aggregate( 'ARMOIREETLAMPES','count',"CODE")

Show right values on preview, works well with a field, but don't work with a virtual field (show NULL).

#3 - 2017-07-12 02:39 PM - Patrice Vetsel -

- Affected QGIS version changed from 2.18.0 to 2.18.10

I can confirm this bug too on 2.18.10
#4 - 2017-07-12 03:10 PM - Giovanni Manghi

It also still affects master.

#5 - 2017-07-17 04:49 AM - Nyall Dawson

- Status changed from Open to Closed

- % Done changed from 0 to 100

Applied in changeset commit:qgis|3f4d6de54b476176724877c5a490665fa3dcb9df.

#6 - 2017-11-14 10:41 AM - Frank Broniewski

Is the fix already implemented in 2.18.14? I am having this issue too, the right values on preview and in fields, but not working with virtual fields.

#7 - 2017-11-14 10:56 AM - jd lom

Frank Broniewski wrote:

Is the fix already implemented in 2.18.14? I am having this issue too, the right values on preview and in fields, but not working with virtual fields.

The fix is only implementend on master. Not sure it will be on 2.18.

#8 - 2017-11-15 12:31 PM - Frank Broniewski

jd lom wrote:

Frank Broniewski wrote:

Is the fix already implemented in 2.18.14? I am having this issue too, the right values on preview and in fields, but not working with virtual fields.

The fix is only implementend on master. Not sure it will be on 2.18.

Ah, OK thanks for the info. Luckily I got around the problem by using a OGR virtual file.

#9 - 2018-06-15 10:30 AM - Dan Isaacs

Nyall Dawson wrote:

Applied in changeset commit:qgis|3f4d6de54b476176724877c5a490665fa3dcb9df.

I've just come across this problem in 2.18.18. When you say it's been implemented on the master, does this mean that, for me, the only way to get this

problem fixed is to move to 3.0, or this there some patch I could apply?
Files

test_aggregate_functions_virtual_field.zip 8.46 KB 2016-12-02 jd lom
